/*********************************************************************
 *                Microchip USB C18 Firmware Version 1.0
 *********************************************************************
 * FileName:        user.c
 * Dependencies:    See INCLUDES section below
 * Processor:       PIC18
 * Compiler:        C18 2.30.01+
 *****************************************************************************/

/** I N C L U D E S **********************************************************/
#include "system\typedefs.h"
#include <timers.h>
#include "system\usb\usb.h"
#include "io_cfg.h"             // I/O pin mapping
#include "user\user.h"
#include <delays.h>   /* for 'Delay10KTCYx'      */
#include <string.h> 
#include <stdlib.h>
#include <math.h>

/** V A R I A B L E S ********************************************************/

char input_buffer[64];
unsigned char output_buffer[128];
int iBufIdx=0;          //indeks dla output_buffer
rom char welcome[]={"PIC18F4550 Full-Speed USB - CDC RS-232 Emulation Demo\r\n\r\n"};

int tempBufferSize=64;	////ilosc bajtow danych do zbuforowania przed wyslaniem do hosta

/** P R I V A T E  P R O T O T Y P E S ***************************************/
void InitializeUSART(void);
void BlinkUSBStatus(void);


void beep(void);

/** D E C L A R A T I O N S **************************************************/

void UserInit(void)
{  
   int i;
	mInitBuzzer();
   for(i=0;i<128;i++)
      output_buffer[i]=i;
	beep();
	beep();
}//end UserInit



/******************************************************************************
 * Function:        void ProcessIO(void)
 * PreCondition:    None
 * Overview:        This function is a place holder for other user routines.
 *                  It is a mixture of both USB and non-USB tasks.
 * Note:            None
 *****************************************************************************/
void ProcessIO(void)
{   
   if((usb_device_state < CONFIGURED_STATE)||(UCONbits.SUSPND==1)) return;
   if(mUSBUSARTIsTxTrfReady())	
     {
      mUSBUSARTTxRam((byte *)output_buffer,128);
     }
}//end ProcessIO

void beep(void)
	{
	//buzzer do PB3
	PORTB |= 0b00001000;
	Delay10KTCYx (25);   /* pause for a moment (50 * 4 * 10,000 cycles) */
	PORTB &= 0b11110111;
	}
