//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <inifiles.hpp>
#include "mainUnit.h"
#include "about.h"
#include "settings.h"
#include "RSreadThread.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
TRead *ReadThread;  //watek odczytu danych z RS232

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
bufLock = new TCriticalSection();
//inicjalizacja - plik ini o tej samej nazwie jak plik exe
TIniFile *ini;
ini = new TIniFile( ChangeFileExt( Application->ExeName, ".ini" ) );
hComm=INVALID_HANDLE_VALUE;
COMnumber =  ini->ReadInteger( "COM", "COMnumber", 1);
delete ini;
}


void __fastcall TForm1::FormCreate(TObject *Sender)
{
//
}
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{
AboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
Form1->Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
//save settings to ini file
//przejsc na TMemIniFile jesli ilosc zapisywanych danych znacznie wzrosnie
TIniFile *ini;
ini = new TIniFile(ChangeFileExt( Application->ExeName, ".ini" ) );
ini->WriteInteger ( "COM", "COMnumber", Form1->COMnumber );
delete ini;
delete bufLock;
if(hComm!=INVALID_HANDLE_VALUE)
    {
    ChangeReadThreadState(0);
    PurgeComm(hComm, PURGE_RXABORT);
    CloseHandle(hComm);
    hComm=INVALID_HANDLE_VALUE;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Basicsettings1Click(TObject *Sender)
{
SettingsForm->ShowModal();
}
//---------------------------------------------------------------------------

//otwarcie portu COM
void __fastcall TForm1::OpenCOMport(int COMnumber)
{
DCB dcbCommPort;
COMMTIMEOUTS ctmoNew = {0}, ctmoOld;
char textbuf[50];   //pomocniczy bufor tekstowy
char textbuf2[50];   //pomocniczy bufor tekstowy

if(hComm==NULL||hComm==INVALID_HANDLE_VALUE) //nie otwarto jeszcze portu
  {
  strcpy(textbuf,"COM");
  itoa(COMnumber,textbuf2,10);
  strcat(textbuf,textbuf2);
  hComm = CreateFile(textbuf, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
  if(hComm!=INVALID_HANDLE_VALUE)   //port open failed
    {
    //leave default COM settings
    strcpy(textbuf2, " opened.");
    strcat(textbuf,textbuf2);
    StatusBar1->Panels->Items[1]->Text=textbuf;
    }
  else
    {
    //error msg
    strcpy(textbuf2,"Failed opening port ");
    strcat(textbuf2,textbuf);
    strcat(textbuf2,".");
    StatusBar1->Panels->Items[1]->Text=textbuf2;
    }
  }
}


void __fastcall TForm1::ChangeReadThreadState(int stan)
{
if(stan==0)
    {
    ReadThread->Terminate();
    Sleep(300);                 //wait for terminate
    }
else if(stan!=0) ReadThread = new TRead(false);     //be carefull
}


void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
Timer1->Enabled=false;
OpenCOMport(COMnumber);
Sleep(300);
if(hComm!=INVALID_HANDLE_VALUE)
    {
    ReadThread = new TRead(false);
    }
}
//---------------------------------------------------------------------------

